diff --git a/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
index 13e3af427..b03aa8d7a 100644
--- a/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
 //            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
@@ -63,11 +64,11 @@ public abstract class SaplingBaseBlock extends FlowerBlock implements IBonemeala
     }
     
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced){
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced){
         if(!world.isClientSide)
         {
             ((SaplingBaseBlock)Block.blocksList[id]).growTree(world, blockX, blockY, blockZ, world.rand);
-            if (entityplayer.getGamemode().consumeBlocks())
+            if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
             }
diff --git a/src/main/java/net/minecraft/core/block/SlabBlock.java b/src/main/java/net/minecraft/core/block/SlabBlock.java
index d0a5116fe..d640de755 100644
--- a/src/main/java/net/minecraft/core/block/SlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/SlabBlock.java
@@ -14,6 +14,7 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -187,7 +188,7 @@ public class SlabBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
     	Direction dir = mob.getVerticalPlacementDirection(side, sideHeight);
     	if(dir == Direction.DOWN) {
             world.setBlockMetadataWithNotify(x, y, z, 0);
diff --git a/src/main/java/net/minecraft/core/block/SpikesBlock.java b/src/main/java/net/minecraft/core/block/SpikesBlock.java
index 264769122..7eb59e2d6 100644
--- a/src/main/java/net/minecraft/core/block/SpikesBlock.java
+++ b/src/main/java/net/minecraft/core/block/SpikesBlock.java
@@ -13,6 +13,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class SpikesBlock extends Block
 {
@@ -23,7 +24,7 @@ public class SpikesBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         if (world.isClientSide) {
             return;
         }
@@ -65,10 +66,10 @@ public class SpikesBlock extends Block
 		
 		if(isPowered != wasPowered) {
 			if(isPowered) {
-				world.playSoundEffect(null, 1007, x, y, z, 0);
+				world.playBlockEvent(null, 1007, x, y, z, 0);
 				world.setBlockMetadataWithNotify(x, y, z, 1);
 			}else {
-				world.playSoundEffect(null, 1006, x, y, z, 0);
+				world.playBlockEvent(null, 1006, x, y, z, 0);
 				world.setBlockMetadataWithNotify(x, y, z, 0);
 			}
 		}
diff --git a/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java b/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java
index 313f005cc..fb726d84b 100644
--- a/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java
+++ b/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 /**
  * Represents a flower block that can store multiple flowers within itself, up to a maximum of 4.
@@ -21,7 +22,7 @@ public class StackedFlowerBlock extends FlowerBlock {
     }
 
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
         final int metadata = stack.getMetadata();
         return setPermanent(metadata, true);
     }
diff --git a/src/main/java/net/minecraft/core/block/StairsBlock.java b/src/main/java/net/minecraft/core/block/StairsBlock.java
index e76946f91..39336b3c0 100644
--- a/src/main/java/net/minecraft/core/block/StairsBlock.java
+++ b/src/main/java/net/minecraft/core/block/StairsBlock.java
@@ -16,6 +16,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, World, Mob, MathHelper,
@@ -306,7 +307,7 @@ public class StairsBlock extends Block
     }
     
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
 //    	System.out.println("Placed Side: "+side+" Height: "+sideHeight);
     	
         int meta = world.getBlockMetadata(x, y, z) & 0xF0;
diff --git a/src/main/java/net/minecraft/core/block/SugarcaneBlock.java b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
index b0ac21819..261a510c6 100644
--- a/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
+++ b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
@@ -12,6 +12,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -137,11 +138,11 @@ public class SugarcaneBlock extends Block implements IBonemealable
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
         {
             ((SugarcaneBlock)Block.blocksList[id]).growReedOnTop(world, blockX, blockY, blockZ);
-            if (entityplayer.getGamemode().consumeBlocks())
+            if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
             }
diff --git a/src/main/java/net/minecraft/core/block/TorchBlock.java b/src/main/java/net/minecraft/core/block/TorchBlock.java
index c0174f91a..2481adc2c 100644
--- a/src/main/java/net/minecraft/core/block/TorchBlock.java
+++ b/src/main/java/net/minecraft/core/block/TorchBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
@@ -72,7 +73,7 @@ public class TorchBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
     	int l = side.getId();
         int i1 = world.getBlockMetadata(x, y, z);
         if(l == 1 && canPlaceOnTop(world, x, y - 1, z))
diff --git a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
index 719283f39..ea399580d 100644
--- a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block;
 
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -8,19 +9,25 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, IBlockAccess, World, 
 //            AxisAlignedBB, Player, Vec3D, MovingObjectPosition
 
-public class TrapDoorBlock extends Block implements IPaintable {
+public class TrapDoorBlock extends Block {
+    public static final int MASK_DIRECTION = 0b0000_0011;
+    public static final int MASK_OPEN = 0b0000_0100;
+    public static final int MASK_UPPER_HALF = 0b0000_1000;
+
     public TrapDoorBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
         float f = 0.5F;
@@ -29,16 +36,15 @@ public class TrapDoorBlock extends Block implements IPaintable {
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
         super.onBlockPlacedByMob(world, x, y, z, side, mob, sideHeight);
 
         int meta = world.getBlockMetadata(x, y, z);
-        final boolean isPowered = world.hasNeighborSignal(x, y, z);
+        boolean isOpened = isTrapdoorOpen(meta);
+        boolean isPowered = world.hasNeighborSignal(x, y, z);
 
-        if (isPowered) {
-            meta = setTrapdoorPowered(meta, true);
-            meta = setTrapdoorOpen(meta, true);
-            world.setBlockMetadataWithNotify(x, y, z, setTrapdoorPowered(meta, true));
+        if (isOpened != isPowered) {
+            world.setBlockMetadataWithNotify(x, y, z, setTrapdoorOpen(meta, isPowered));
         }
     }
 
@@ -106,12 +112,21 @@ public class TrapDoorBlock extends Block implements IPaintable {
         if (blockMaterial != Material.metal) {
             int l = world.getBlockMetadata(x, y, z);
             world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
-            world.playSoundEffect(player, 1003, x, y, z, 0);
+            world.playBlockEvent(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
             return true;
         }
         return false;
     }
 
+    @Override
+    public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
+        if (blockMaterial != Material.metal) {
+            int l = world.getBlockMetadata(x, y, z);
+            world.setBlockMetadataWithNotify(x, y, z, l ^ 4);
+            world.playBlockEvent(null, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
+        }
+    }
+
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         if (world.isClientSide) {
@@ -119,16 +134,12 @@ public class TrapDoorBlock extends Block implements IPaintable {
         }
 
         int meta = world.getBlockMetadata(x, y, z);
-        final boolean wasPowered = isTrapdoorPowered(meta);
-        final boolean isPowered = world.hasNeighborSignal(x, y, z);
+        boolean isOpened = isTrapdoorOpen(meta);
+        boolean isPowered = world.hasNeighborSignal(x, y, z);
 
-        if (wasPowered != isPowered) {
-            if (isPowered != isTrapdoorOpen(meta)) {
-                world.playSoundEffect(null, 1003, x, y, z, 0);
-            }
-            meta = setTrapdoorPowered(meta, isPowered);
-            meta = setTrapdoorOpen(meta, isPowered);
-            world.setBlockMetadataWithNotify(x, y, z, setTrapdoorPowered(meta, isPowered));
+        if (isOpened != isPowered) {
+            world.setBlockMetadataWithNotify(x, y, z, setTrapdoorOpen(meta, isPowered));
+            world.playBlockEvent(null, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
         }
     }
 
@@ -139,10 +150,10 @@ public class TrapDoorBlock extends Block implements IPaintable {
     }
 
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
-        int meta = getMetaForDirection(player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
-        if (player.getVerticalPlacementDirection(side, yPlaced) == Direction.UP) {
-            meta = setUpperHalf(meta, true);
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+        int meta = getMetaForDirection(player == null ? side.getDirection().getOpposite() : player.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
+        if (player != null && player.getVerticalPlacementDirection(side, yPlaced) == Direction.UP) {
+            meta |= 8;
         }
         return meta;
     }
@@ -161,65 +172,37 @@ public class TrapDoorBlock extends Block implements IPaintable {
     }
 
     public static boolean isTrapdoorOpen(int metadata) {
-        return (metadata & 0b0000_0100) != 0;
+        return (metadata & MASK_OPEN) != 0;
     }
 
     public static int setTrapdoorOpen(int metadata, boolean isOpen) {
         if (isOpen) {
-            metadata |= 0b0000_0100;
+            metadata |= MASK_OPEN;
         } else {
-            metadata &= 0b1111_1011;
-        }
-        return metadata;
-    }
-
-    public static boolean isTrapdoorPowered(int metadata) {
-        return (metadata & 0b0001_0000) != 0;
-    }
-
-    public static int setTrapdoorPowered(int metadata, boolean isPowered) {
-        if (isPowered) {
-            metadata |= 0b0001_0000;
-        } else {
-            metadata &= 0b1110_1111;
+            metadata &= ~MASK_OPEN;
         }
         return metadata;
     }
 
     public static boolean isUpperHalf(int meta) {
-        return (meta & 8) != 0;
+        return (meta & MASK_UPPER_HALF) != 0;
     }
 
-    public static int setUpperHalf(int metadata, boolean isUpperHalf) {
+    public static int setUpperHalf(int meta, boolean isUpperHalf) {
         if (isUpperHalf) {
-            metadata |= 0b0000_1000;
+            meta |= MASK_UPPER_HALF;
         } else {
-            metadata &= 0b1111_0111;
+            meta &= ~MASK_UPPER_HALF;
         }
-        return metadata;
+        return meta;
     }
 
     public int getMetaForDirection(Direction dir) {
-        if (dir == Direction.NORTH) return 1;
-        if (dir == Direction.EAST) return 2;
-        if (dir == Direction.SOUTH) return 0;
-        if (dir == Direction.WEST) return 3;
-        return 0;
+        return dir.getId();
     }
 
-    public Direction getDirectionForMeta(int metadata) {
-        metadata = metadata & 3;
-        if (metadata == 0) return Direction.SOUTH;
-        if (metadata == 1) return Direction.NORTH;
-        if (metadata == 2) return Direction.EAST;
-        if (metadata == 3) return Direction.WEST;
-        return Direction.NONE;
-    }
-
-    @Override
-    public void setColor(World world, int x, int y, int z, DyeColor color) {
-        final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadata(x, y, z, Blocks.TRAPDOOR_PLANKS_PAINTED.id, meta);
-        ((IPaintable) Blocks.TRAPDOOR_PLANKS_PAINTED).setColor(world, x, y, z, color);
+    public Direction getDirectionForMeta(int meta) {
+        meta = meta & MASK_DIRECTION;
+        return Direction.getDirectionById(meta);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java b/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
new file mode 100644
index 000000000..8b2403694
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
@@ -0,0 +1,29 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+
+public abstract class VeryRotatableEntityBlock extends RotatableEntityBlock {
+	public VeryRotatableEntityBlock(String key, String namespaceId, int id, Material material) {
+        super(key, namespaceId, id, material);
+    }
+
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+        final Direction direction = mob.getPlacementDirection(side).getOpposite();
+
+        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+    }
+
+    public static int directionToMeta(Direction direction) {
+        return direction.getId() & 7;
+    }
+
+    public static Direction metaToDirection(int meta) {
+        return Direction.getDirectionById(meta & 7);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/WoolBlock.java b/src/main/java/net/minecraft/core/block/WoolBlock.java
index 95b3062ad..e0d5a70ed 100644
--- a/src/main/java/net/minecraft/core/block/WoolBlock.java
+++ b/src/main/java/net/minecraft/core/block/WoolBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public class WoolBlock extends Block implements IPainted
 {
@@ -17,7 +18,7 @@ public class WoolBlock extends Block implements IPainted
     }
     
     @Override
-    public int getPlacedBlockMetadata(Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
     	return stack.getMetadata() & 0xF;
     }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/ActivatorBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/ActivatorBlockEntity.java
new file mode 100644
index 000000000..5676b4578
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/entity/ActivatorBlockEntity.java
@@ -0,0 +1,239 @@
+package net.minecraft.core.block.entity;
+
+import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.ListTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.RotatableBlock;
+import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class ActivatorBlockEntity extends BlockEntity implements Container {
+    public static final int CONTAINER_SIZE = 9;
+    private ItemStack[] dispenserContents;
+    private final Random random;
+    protected short lockedSlotBitSet;
+    public int stackSelector = 0;
+
+    public ActivatorBlockEntity()
+    {
+        dispenserContents = new ItemStack[CONTAINER_SIZE];
+        random = new Random();
+    }
+
+    @Override
+    public int getContainerSize()
+    {
+        return CONTAINER_SIZE;
+    }
+
+    @Override
+    public ItemStack getItem(int index)
+    {
+        return dispenserContents[index];
+    }
+
+    @Override
+    public ItemStack removeItem(int index, int takeAmount)
+    {
+        if(dispenserContents[index] != null)
+        {
+            if(dispenserContents[index].stackSize <= takeAmount)
+            {
+                ItemStack itemstack = dispenserContents[index];
+                dispenserContents[index] = null;
+                setChanged();
+                return itemstack;
+            }
+            ItemStack itemstack1 = dispenserContents[index].splitStack(takeAmount);
+            if(dispenserContents[index].stackSize <= 0)
+            {
+                dispenserContents[index] = null;
+            }
+            setChanged();
+            return itemstack1;
+        } else
+        {
+            return null;
+        }
+    }
+
+    public ItemStack getNextStack()
+    {
+        if (locked(stackSelector)) {
+            shiftSelector();
+            return null;
+        }
+        int itemIndex = stackSelector;
+        shiftSelector();
+        return getItem(itemIndex);
+    }
+
+    public void shiftSelector() {
+        stackSelector = (stackSelector + 1) % CONTAINER_SIZE;
+        int i = 0;
+        while (locked(stackSelector)) {
+            i++;
+            stackSelector = (stackSelector + 1) % CONTAINER_SIZE;
+            if (i >= CONTAINER_SIZE) {
+                stackSelector = 0;
+                break;
+            }
+        }
+    }
+
+    public void nullDeadItems() {
+        for (int i = 0; i < dispenserContents.length; i++) {
+            if (dispenserContents[i] != null && dispenserContents[i].stackSize <= 0) {
+                dispenserContents[i] = null;
+            }
+        }
+    }
+
+    public void lockSlot(int slot, boolean flag) {
+        assert slot >= 0 && slot < CONTAINER_SIZE : "Target slot to lock is outside the container bounds";
+        int mask = 0b1 << slot;
+        if (flag) {
+            lockedSlotBitSet |= (short) mask;
+        } else {
+            lockedSlotBitSet &= (short) ~mask;
+        }
+        if (locked(stackSelector)) {
+            shiftSelector();
+        }
+    }
+
+    @Override
+    public boolean locked(int slot) {
+        assert slot >= 0 && slot < CONTAINER_SIZE : "Target slot to lock is outside the container bounds";
+        int mask = 0b1 << slot;
+        return (lockedSlotBitSet & mask) != 0;
+    }
+
+    @Override
+    public void setItem(int index, ItemStack itemstack)
+    {
+        dispenserContents[index] = itemstack;
+        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
+        {
+            itemstack.stackSize = getMaxStackSize();
+        }
+        setChanged();
+    }
+
+    @Override
+    public String getName()
+    {
+        return "Activator";
+    }
+
+    @Override
+    public void readFromNBT(CompoundTag compoundTag)
+    {
+        super.readFromNBT(compoundTag);
+        stackSelector = compoundTag.getByte("Selector");
+        lockedSlotBitSet = compoundTag.getShort("LockedSlots");
+        ListTag itemListTag = compoundTag.getList("Items");
+        dispenserContents = new ItemStack[getContainerSize()];
+        for(int i = 0; i < itemListTag.tagCount(); i++)
+        {
+            CompoundTag slotTag = (CompoundTag)itemListTag.tagAt(i);
+            int j = slotTag.getByte("Slot") & 0xff;
+            if(j < dispenserContents.length)
+            {
+                dispenserContents[j] = ItemStack.readItemStackFromNbt(slotTag);
+            }
+        }
+
+    }
+
+    @Override
+    public void writeToNBT(CompoundTag compoundTag)
+    {
+        super.writeToNBT(compoundTag);
+        compoundTag.putByte("Selector", (byte) stackSelector);
+        compoundTag.putShort("LockedSlots", lockedSlotBitSet);
+        ListTag itemListTag = new ListTag();
+        for(int i = 0; i < dispenserContents.length; i++)
+        {
+            if(dispenserContents[i] != null)
+            {
+                CompoundTag slotTag = new CompoundTag();
+                slotTag.putByte("Slot", (byte)i);
+                dispenserContents[i].writeToNBT(slotTag);
+                itemListTag.addTag(slotTag);
+            }
+        }
+
+        compoundTag.put("Items", itemListTag);
+    }
+
+    @Override
+    public int getMaxStackSize()
+    {
+        return 64;
+    }
+
+    @Override
+    public boolean stillValid(Player entityplayer)
+    {
+        if(worldObj.getBlockEntity(x, y, z) != this)
+        {
+            return false;
+        }
+        return entityplayer.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
+    }
+
+    @Override
+    public void sortContainer() {
+        // Do nothing
+    }
+
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        label0:
+        for (int l = 0; l < this.getContainerSize(); l++) {
+            ItemStack itemstack = this.getItem(l);
+            if (itemstack == null) {
+                continue;
+            }
+            float f = random.nextFloat() * 0.8F + 0.1F;
+            float f1 = random.nextFloat() * 0.8F + 0.1F;
+            float f2 = random.nextFloat() * 0.8F + 0.1F;
+            do {
+                if (itemstack.stackSize <= 0) {
+                    continue label0;
+                }
+                int i1 = random.nextInt(21) + 10;
+                if (i1 > itemstack.stackSize) {
+                    i1 = itemstack.stackSize;
+                }
+                itemstack.stackSize -= i1;
+                ItemEntity item = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                float f3 = 0.05F;
+                item.xd = (float) random.nextGaussian() * f3;
+                item.yd = (float) random.nextGaussian() * f3 + 0.2F;
+                item.zd = (float) random.nextGaussian() * f3;
+                world.entityJoinedWorld(item);
+            } while (true);
+        }
+    }
+
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return true;
+    }
+
+    @Override
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, RotatableBlock.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntityDispatcher.java b/src/main/java/net/minecraft/core/block/entity/BlockEntityDispatcher.java
index 953a78d42..69971c553 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlockEntityDispatcher.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntityDispatcher.java
@@ -63,10 +63,12 @@ public class BlockEntityDispatcher {
 
     static
     {
+        // TODO make these ids namespaced
         addMapping(FurnaceBlockEntity.class, "Furnace");
         addMapping(ChestBlockEntity.class, "Chest");
         addMapping(JukeboxBlockEntity.class, "RecordPlayer");
         addMapping(DispenserBlockEntity.class, "Trap");
+        addMapping(ActivatorBlockEntity.class, "Activator");
         addMapping(SignBlockEntity.class, "Sign");
         addMapping(MobSpawnerBlockEntity.class, "MobSpawner");
         addMapping(NoteBlockEntity.class, "Music");
diff --git a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
index 4dc9298a7..5e02514dc 100644
--- a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.RotatableBlock;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
@@ -10,14 +11,11 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-// Referenced classes of package net.minecraft.src:
-//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
-//            NBTTagList, World, Player
-
 public class DispenserBlockEntity extends BlockEntity
     implements Container
 {
@@ -209,7 +207,7 @@ public class DispenserBlockEntity extends BlockEntity
 
     @Override
     public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
-        return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
+        return super.getCarriedEntry(world, holder, currentBlock, RotatableBlock.setDirection(currentMeta, Direction.NORTH) /*Reset rotation, primarily to make it render in hand properly*/);
     }
 
     private ItemStack dispenserContents[];
diff --git a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
index 311a622a6..0c6fc6ebe 100644
--- a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
@@ -5,7 +5,6 @@ package net.minecraft.core.block.entity;
 //            BlockEntity, NBTTagCompound
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.LevelListener;
@@ -54,7 +53,7 @@ public class JukeboxBlockEntity extends BlockEntity {
             item.pickupDelay = 10;
             world.entityJoinedWorld(item);
 
-            world.playSoundEffect(LevelListener.EVENT_JUKEBOX_TOGGLE, x, y, z, 0);
+            world.playBlockEvent(LevelListener.EVENT_JUKEBOX_TOGGLE, x, y, z, 0);
             world.playRecord(null, null, x, y, z);
             record = 0;
             setChanged();
